% Read configuration.
fid = fopen('C:\ANTON\visit to France\_tmp\conf_infol','r');
Kend=fread(fid,1,'int'); % number of scales
N_nu=fread(fid,Kend,'int'); % number of rotations per scale
N1=fread(fid,Kend,'int'); N2=fread(fid,Kend,'int'); % grid size on a box per scale
L1=fread(fid,Kend,'double'); L2=fread(fid,Kend,'double'); % length of a box per scale
K1low=fread(fid,Kend,'double'); K1=fread(fid,Kend,'double'); % small radius and half outer radius per scale
for kk=1:Kend
    boxw1{kk}=reshape(fread(fid,N_nu(kk)*3,'double'),3,N_nu(kk));  % radial orientation vector
end
for kk=1:Kend
    boxw2{kk}=reshape(fread(fid,N_nu(kk)*3,'double'),3,N_nu(kk));
end
for kk=1:Kend
    boxw3{kk}=reshape(fread(fid,N_nu(kk)*3,'double'),3,N_nu(kk));
end
fclose(fid);

% -------------------  Read curvelet coefficients.
Nangles=N_nu/2; Nangles(1)=1; 

clear indk; indk=cell(2,Nangles(2));
clear val; val=cell(2,Nangles(2));
clear ccabs; ccabs=cell(2,Nangles(2));

fid = fopen('C:\ANTON\visit to France\_tmp\lens_srt_128-128-128.dat_cc_info-k1','r');
ccnum{1}=fread(fid,Nangles(2),'int');
fclose(fid);
fid = fopen('C:\ANTON\visit to France\_tmp\lens_srt_128-128-128.dat_cc_ind-k1','r');
for nu=1:Nangles(2)
    indk{1}{nu}=fread(fid,ccnum{1}(nu),'int');
end
fclose(fid);
fid = fopen('C:\ANTON\visit to France\_tmp\lens_srt_128-128-128.dat_cc_val-k1','r');
for nu=1:Nangles(2)
    val{1}{nu}=fread(fid,2*ccnum{1}(nu),'float');
end
fclose(fid);

for nu=1:Nangles(2)
    tmp=zeros(2*ccnum{1}(nu),1);
    ccabs{1}{nu}=zeros(ccnum{1}(nu),1); tmp1=zeros(ccnum{1}(nu),1);
    tmp=val{1}{nu}.^2; tmp=tmp+circshift(tmp,-1);
    for jj=1:ccnum{1}(nu)
        tmp1(jj)=tmp(2*jj-1);
    end
    ccabs{1}{nu}=sqrt(tmp1); 
end

% for nu=1:Nangles(2)
%     for jj=1:ccnum1(nu)
%         ccabs{1}{nu}(jj)=sqrt((val1{nu}(2*jj-1))^2+(val1{nu}(2*jj))^2);
%     end
% end
mccabs1=zeros(Nangles(2),1);
for nu=1:Nangles(2)
    if(ccnum{1}(nu)>0) 
        mccabs1(nu)=max(ccabs{1}{nu}(:));
    end
end

fid = fopen('C:\ANTON\visit to France\_tmp\lens_srt_128-128-128.dat_cc_info-k2','r');
ccnum{2}=fread(fid,Nangles(3),'int');
fclose(fid);
fid = fopen('C:\ANTON\visit to France\_tmp\lens_srt_128-128-128.dat_cc_ind-k2','r');
for nu=1:Nangles(3)
    indk{2}{nu}=fread(fid,ccnum{2}(nu),'int');
end
fclose(fid);
fid = fopen('C:\ANTON\visit to France\_tmp\lens_srt_128-128-128.dat_cc_val-k2','r');
for nu=1:Nangles(3)
    val{2}{nu}=fread(fid,2*ccnum{2}(nu),'float');
end
fclose(fid);

for nu=1:Nangles(3)
    tmp=zeros(2*ccnum{2}(nu),1);
    ccabs{2}{nu}=zeros(ccnum{2}(nu),1); tmp1=zeros(ccnum{2}(nu),1);
    tmp=val{2}{nu}.^2; tmp=tmp+circshift(tmp,-1);
    for jj=1:ccnum{2}(nu)
        tmp1(jj)=tmp(2*jj-1);
    end
    ccabs{2}{nu}=sqrt(tmp1); 
end

%----------------------------------------------------







figure
plot(mccabs1)
hold on
plot(mccabs2,'r')

% -----------------------     Read image.
NS=128; NR=128; NT=128;
cube=ones(128,128,128);
fid = fopen('C:\ANTON\visit to France\_tmp\lens_srt_128-128-128.dat','r');
cube=reshape(fread(fid,NS*NR*NT,'float'),NS,NR,NT);
fclose(fid);

figure
p=slice(permute(cube,[3 2 1]),110,110,[])
%axis([0 128 0 128 0 128]);
daspect([1 1 1])
colormap(bone)
set(p,'FaceColor','interp','EdgeColor','none')
axis tight

% ------------    Test box coeff.

nnu=15; kk=2; penalty=.008; % penalty=.8;
ccoef=zeros(N1(kk)*N2(kk)*N2(kk),1);
if(ccnum{kk-1}(nnu)>0)
    for jj=1:ccnum{kk-1}(nnu)
        if ccabs{kk-1}{nnu}(jj)>penalty
            ccoef(indk{kk-1}{nnu}(jj)+1)=ccabs{kk-1}{nnu}(jj);
        end
    end
end
ccoef=reshape(ccoef,N2(kk),N2(kk),N1(kk));

[nxi1,nxi2,nxi3] = meshgrid(1:N2(kk),1:N2(kk),1:N1(kk));
ThetInv=[boxw1{kk}(:,nnu) boxw2{kk}(:,nnu) boxw3{kk}(:,nnu)]
step_x1=(2*K1(kk)-K1low(kk))/(N1(kk)-1); step_x2=L2(kk)/(N2(kk)-1);
x1st=K1low(kk); x2st=-L2(kk)/2;

Xi=zeros(3,N1(kk)*N2(kk)*N2(kk));
for j1=1:N1(kk)
    for j2=1:N2(kk)
        for j3=1:N2(kk)
            Xi(1,j3+N2(kk)*((j2-1)+N2(kk)*(j1-1)))=x1st + (j1-1)*step_x1;
            Xi(2,j3+N2(kk)*((j2-1)+N2(kk)*(j1-1)))=x2st + (j2-1)*step_x2;
            Xi(3,j3+N2(kk)*((j2-1)+N2(kk)*(j1-1)))=x2st + (j3-1)*step_x2;
        end
    end
end
xi1=reshape(Xi(1,:),N2(kk),N2(kk),N1(kk));
xi2=reshape(Xi(2,:),N2(kk),N2(kk),N1(kk));
xi3=reshape(Xi(3,:),N2(kk),N2(kk),N1(kk));
for jj=1:(N1(kk)*N2(kk)*N2(kk))
    Xi(:,jj)=ThetInv*Xi(:,jj);
end
Xi1=reshape(Xi(1,:),N2(kk),N2(kk),N1(kk));
Xi2=reshape(Xi(2,:),N2(kk),N2(kk),N1(kk));
Xi3=reshape(Xi(3,:),N2(kk),N2(kk),N1(kk));


    v  = [(K1low(kk)*boxw1{kk}(:,nnu)+L2(kk)/2*(-boxw2{kk}(:,nnu)-boxw3{kk}(:,nnu)))';(K1low(kk)*boxw1{kk}(:,nnu)+L2(kk)/2*(-boxw2{kk}(:,nnu)+boxw3{kk}(:,nnu)))';(K1low(kk)*boxw1{kk}(:,nnu)+L2(kk)/2*(boxw2{kk}(:,nnu)+boxw3{kk}(:,nnu)))';(K1low(kk)*boxw1{kk}(:,nnu)+L2(kk)/2*(boxw2{kk}(:,nnu)-boxw3{kk}(:,nnu)))'; ...
         (2*K1(kk)*boxw1{kk}(:,nnu)+L2(kk)/2*(-boxw2{kk}(:,nnu)-boxw3{kk}(:,nnu)))';(2*K1(kk)*boxw1{kk}(:,nnu)+L2(kk)/2*(-boxw2{kk}(:,nnu)+boxw3{kk}(:,nnu)))';(2*K1(kk)*boxw1{kk}(:,nnu)+L2(kk)/2*(boxw2{kk}(:,nnu)+boxw3{kk}(:,nnu)))';(2*K1(kk)*boxw1{kk}(:,nnu)+L2(kk)/2*(boxw2{kk}(:,nnu)-boxw3{kk}(:,nnu)))'];
    f = [1 2 3 4; 1 2 6 5; 2 3 7 6; 3 4 8 7; 4 1 5 8; 5 6 7 8];
 
dd=max(abs(ccoef(:)));    
psize=ccoef/max(ccoef(:))*40+1; 
ind=(psize(:)>15);

[xs,ys,zs] = sphere(100);  % GRAY SPHERE
xs=xs*K1low(kk); ys=ys*K1low(kk); zs=zs*K1low(kk);

figure
scatter3(Xi1(ind),Xi2(ind),Xi3(ind),'.r')
hold on
surf(xs,ys,zs,'FaceColor',[.8 .8 .8],'EdgeColor','none')
  patch('Vertices',v,'Faces',f,'FaceColor','none','LineWidth',1);
daspect([1 1 1])
axis([-40 40 -40 40 -4 40]);
    


% ================================================

ThetInv=[boxw1{kk}(:,nnu) boxw2{kk}(:,nnu) boxw3{kk}(:,nnu)]
step_x1=1/L1(kk); step_x2=1/L2(kk);
x1st=-N1(kk)/2*step_x1; x2st=-N2(kk)/2*step_x2;

XYZ=zeros(3,N1(kk)*N2(kk)*N2(kk));
for j1=1:N1(kk)
    for j2=1:N2(kk)
        for j3=1:N2(kk)
            XYZ(1,j3+N2(kk)*((j2-1)+N2(kk)*(j1-1)))=x1st + (j1-1)*step_x1;
            XYZ(2,j3+N2(kk)*((j2-1)+N2(kk)*(j1-1)))=x2st + (j2-1)*step_x2;
            XYZ(3,j3+N2(kk)*((j2-1)+N2(kk)*(j1-1)))=x2st + (j3-1)*step_x2;
        end
    end
end
X=reshape(XYZ(1,:),N2(kk),N2(kk),N1(kk));
Y=reshape(XYZ(2,:),N2(kk),N2(kk),N1(kk));
Z=reshape(XYZ(3,:),N2(kk),N2(kk),N1(kk));
for jj=1:(N1(kk)*N2(kk)*N2(kk))
    XYZ(:,jj)=ThetInv*XYZ(:,jj)*128+65;
end
XX=reshape(XYZ(1,:),N2(kk),N2(kk),N1(kk));
YY=reshape(XYZ(2,:),N2(kk),N2(kk),N1(kk));
ZZ=reshape(XYZ(3,:),N2(kk),N2(kk),N1(kk));
nnumm=(N1(kk)*N2(kk)*N2(kk));
nnumm=2;
vec=zeros(3,nnumm);
for jj=1:nnumm
    vec(:,jj)=boxw1{kk}(:,nnu);
end
 

figure
subplot(1,2,1)
scatter3(Xi1(ind),Xi2(ind),Xi3(ind),'.r')
hold on
surf(xs,ys,zs,'FaceColor',[.8 .8 .8],'EdgeColor','none')
  patch('Vertices',v,'Faces',f,'FaceColor','none','LineWidth',1);
daspect([1 1 1])
axis([-40 40 -40 40 -4 40]);

subplot(1,2,2)
scatter3(XYZ(1,ind),XYZ(2,ind),XYZ(3,ind),'.r')
daspect([1 1 1])
hold on
%quiver3(XYZ(1,ind),XYZ(2,ind),XYZ(3,ind),vec(1,ind),vec(2,ind),vec(3,ind),2);
quiver3([10 110],[10 110],[10 110],vec(1,:),vec(2,:),vec(3,:),.2,'LineWidth',2);
set(gca,'XLim',[0 128])
set(gca,'XLim',[0 128])
set(gca,'YLim',[0 128], 'ZLim',[0 128])
axis([0 128 0 128 0 128]);



figure
p=slice(permute(cube,[2 3 1]),100,110,20)
%axis([0 128 0 128 0 128]);
daspect([1 1 1])
colormap(bone)
set(p,'FaceColor','interp','EdgeColor','none')
alpha .8;
hold on
scatter3(XYZ(1,ind),XYZ(2,ind),XYZ(3,ind),'.r')


% it was a test (compare with full array written for one box)
% there was wrong reconstruction of coefficients on a box due to differnce
% in indexing in C and matlab
% ----------------------------------------------------
% boxc=zeros(2*N2(kk)*N2(kk)*N1(kk),1);
% fid = fopen('C:\ANTON\visit to France\_tmp\cube_sm_srt_128_128_128.dat_ccoef_k2nu118','r');
%     boxc=fread(fid,2*(N2(kk)*N2(kk)*N1(kk)),'float');
% fclose(fid);
% aboxc=zeros(N2(kk)*N2(kk)*N1(kk),1);
%     for jj=1:(N2(kk)*N2(kk)*N1(kk))
%         aboxc(jj)=sqrt((boxc(2*jj-1))^2+(boxc(2*jj))^2);
%     end
% tmp1=fftshift(reshape(aboxc,N2(kk),N2(kk),N1(kk)));
% ccoef1=tmp1; 
% 
% figure 
% subplot(2,1,1)
% imagesc(squeeze(ccoef(20,:,:)))
% subplot(2,1,2)
% imagesc(squeeze(ccoef(20,:,:))-squeeze(ccoef1(20,:,:)))


% =============== FIGURES ==================================
  % -- Fig 1. - curvelet coefficients (top - isosurface containing large coeff. 
  %                                    bottom - slices through the box)
  
figure
subplot(2,1,1)
dd=max(abs(ccoef(:)));
p = patch(isosurface(permute(ccoef,[1 3 2]),.48*dd));
isonormals(ccoef,p)
set(p,'FaceColor','red');
hold on
daspect([1 1 1])
axis([0 N1(kk) 0 N2(kk) 0 N2(kk)]);
subplot(2,1,2)
p=slice(permute(ccoef,[1 3 2]),[],20,18)
daspect([1 1 1])
axis([0 N1(kk) 0 N2(kk) 0 N2(kk)]);
set(p,'FaceColor','interp','EdgeColor','none')

  % -- Fig 2. - left - box in Fourier space (isosurface)
  %           - right - essential translation grid points (isosurface)
figure
subplot(1,2,1)
dd=max(abs(ccoef(:)));
p = patch(isosurface(Xi1, Xi2, Xi3,ccoef,.48*dd));
isonormals(ccoef,p)
set(p,'FaceColor','red');
hold on
surf(xs,ys,zs,'FaceColor',[.8 .8 .8],'EdgeColor','none')
  patch('Vertices',v,'Faces',f,'FaceColor','none','LineWidth',1);
daspect([1 1 1])
axis([-20 60 -40 40 -4 40]);

subplot(1,2,2)
p = patch(isosurface(XX, YY, ZZ,ccoef,.48*dd));
isonormals(ccoef,p)
set(p,'FaceColor','red');
daspect([1 1 1])
hold on
quiver3([10 110],[10 110],[10 110],vec(1,:),vec(2,:),vec(3,:),.2,'LineWidth',2);
axis([0 128 0 128 0 128]);
daspect([1 1 1])

  % -- Fig 3. - left - box in Fourier space (isosurface)
  %           - right - essential translation grid points (isosurface) +
  %                     data slices
figure
subplot(1,2,1)
dd=max(abs(ccoef(:)));
p = patch(isosurface(Xi1, Xi2, Xi3,ccoef,.48*dd));
isonormals(ccoef,p)
set(p,'FaceColor','red');
%set(p,'FaceColor','red','EdgeColor','none');
hold on
surf(xs,ys,zs,'FaceColor',[.8 .8 .8],'EdgeColor','none')
  patch('Vertices',v,'Faces',f,'FaceColor','none','LineWidth',1);
daspect([1 1 1])
axis([-20 60 -40 40 -4 40]);

subplot(1,2,2), hidden off;
p = patch(isosurface(XX, YY, ZZ,ccoef,.58*dd));
isonormals(ccoef,p)
set(p,'FaceColor','red');
%scatter3(XYZ(1,ind),XYZ(2,ind),XYZ(3,ind),'.r')
daspect([1 1 1])
hold on
quiver3([10 110],[10 110],[10 110],vec(1,:),vec(2,:),vec(3,:),.2,'LineWidth',2);
axis([0 128 0 128 0 128]);
%p=slice(permute(cube,[2 3 1]),30,90,10)
p=slice(permute(cube,[2 3 1]),50,40,[])
set(p,'FaceColor','interp','EdgeColor','none')
alpha .8
daspect([1 1 1])
colormap(bone)
%light


  % -- Fig 4. - Everything

figure
subplot(1,2,1)
dd=max(abs(ccoef(:)));
p = patch(isosurface(permute(ccoef,[1 3 2]),.48*dd));
isonormals(ccoef,p)
set(p,'FaceColor','red');
hold on
daspect([1 1 1])
axis([0 N1(kk) 0 N2(kk) 0 N2(kk)]);
subplot(1,2,2)
p=slice(permute(ccoef,[1 3 2]),[],13,10)
daspect([1 1 1])
axis([0 N1(kk) 0 N2(kk) 0 N2(kk)]);
set(p,'FaceColor','interp','EdgeColor','none')

figure
subplot(1,2,1)
p = patch(isosurface(XX, YY, ZZ,ccoef,.58*dd));
isonormals(ccoef,p)
set(p,'FaceColor','red');
daspect([1 1 1])
hold on
quiver3([10 110],[10 110],[10 110],vec(1,:),vec(2,:),vec(3,:),.2,'LineWidth',2);
axis([0 128 0 128 0 128]);
daspect([1 1 1])

subplot(1,2,2), hidden off;
p = patch(isosurface(XX, YY, ZZ,ccoef,.58*dd));
isonormals(ccoef,p)
set(p,'FaceColor','red');
%scatter3(XYZ(1,ind),XYZ(2,ind),XYZ(3,ind),'.r')
daspect([1 1 1])
hold on
quiver3([10 110],[10 110],[10 110],vec(1,:),vec(2,:),vec(3,:),.2,'LineWidth',2);
axis([0 128 0 128 0 128]);
%p=slice(permute(cube,[2 3 1]),30,90,10)
p=slice(permute(cube,[2 3 1]),50,40,[])
set(p,'FaceColor','interp','EdgeColor','none')
alpha .8
daspect([1 1 1])
colormap(bone)


% ====================================================

psize=ccoef/max(ccoef(:))*60+1; 
ind=(psize(:)>20);

figure
scatter3(nxi1(ind),nxi2(ind),nxi3(ind),psize(ind),ccoef(ind),'filled')
daspect([1 1 1])
axis([0 N2(kk) 0 N2(kk) 0 N1(kk)]);
alpha(.5)

figure
colormap('bone')
scatter3(nxi1(ind),nxi2(ind),nxi3(ind),psize(ind),-ccoef(ind),'filled')
%scatter3(X(ind),Y(ind),Z(ind),psize(ind),'filled')
daspect([1 1 1])
axis([0 N2(kk) 0 N2(kk) 0 N1(kk)]);
alpha(.5)



