#include <iostream.h>
#include <vector>
#include <sfftw.h>
#include <math.h>
#include "dmath.h"
#include "curvelet.h"



int DCurvelet::fftshift3(fftw_complex *f, int* lengths, int l)
{
  int j1,j2,j3, k1,k2;
  int N1=lengths[0], N2=lengths[1], N3=lengths[2];
  fftw_complex *g; g=(fftw_complex *)malloc(N1*N2*N3*sizeof(fftw_complex));
  for (j1=0;j1<N1;j1++)
       for (j2=0;j2<N2;j2++) 
            for (j3=0;j3<N3;j3++) 
             {
                   g[j3+N3*(j2+j1*N2)].re=f[j3+N3*(j2+j1*N2)].re; g[j3+N3*(j2+j1*N2)].im=f[j3+N3*(j2+j1*N2)].im;
             }  

  for (j1=0;j1<N1;j1++)
       for (j2=0;j2<N2;j2++) 
            for (j3=0;j3<N3;j3++)
             {
                     f[j3+N3*(j2+j1*N2)].re=g[(j3+(N3+l)/2)%N3+N3*(((j2+(N2+l)/2)%N2)+((j1+(N1+l)/2)%N1)*N2)].re;
                     f[j3+N3*(j2+j1*N2)].im=g[(j3+(N3+l)/2)%N3+N3*(((j2+(N2+l)/2)%N2)+((j1+(N1+l)/2)%N1)*N2)].im;
              }
  free(g);
  return 0;
}

int DCurvelet::fftshift2(fftw_complex *f, int* lengths, int l)
{
  int j1,j2,j3, k1,k2;
  int N1=lengths[0], N2=lengths[1];
  fftw_complex *g; g=(fftw_complex *)malloc(N1*N2*sizeof(fftw_complex));
  for (j1=0;j1<N1;j1++)
       for (j2=0;j2<N2;j2++)  {   g[j2+j1*N2].re=f[j2+j1*N2].re; g[j2+j1*N2].im=f[j2+j1*N2].im;    }  

  for (j1=0;j1<N1;j1++)
       for (j2=0;j2<N2;j2++)   {
                     f[j2+j1*N2].re=g[( (j2+(N2+l)/2) % N2 )+( (j1+(N1+l)/2)%N1)*N2].re;
                     f[j2+j1*N2].im=g[((j2+(N2+l)/2)%N2)+((j1+(N1+l)/2)%N1)*N2].im;          }
  free(g);
  return 0;
}

int DCurvelet::GetPerfectReconst(char *input_file, int Nx, int Ny, int Nz)
{
   double max_v; 
   int jx, jy, jz;
   long il;
   int N[3]; N[0]=Nx, N[1]=Ny, N[2]=Nz;
   double fft_koef;   fft_koef=1.0/(double)(Nx*Ny*Nz);  //fft_koef=sqrt(fft_koef);
cout << " fft_koef="<<  fft_koef << "\n"; cout.flush();
   int ngrid=Nx*Ny*Nz; 
   fftw_complex ***image = DMath::newC(Nx, Ny, Nz);  memset(&image[0][0][0], '\0', sizeof(fftw_complex)*ngrid);
   fftw_complex ***fft_image = DMath::newC(Nx, Ny, Nz);

   float *inp;     inp=(float*) malloc(ngrid*sizeof(float));
   double *rr;     rr=(double*) malloc(ngrid*sizeof(double));

   FILE *fid;
   fid = fopen(input_file,"rb"); fread(&inp[0], sizeof(float), Nx*Ny*Nz, fid);  fclose (fid); 

    for(jx=0;jx<Nx;jx++)     for(jy=0;jy<Ny;jy++)   for(jz=0;jz<Nz;jz++) {
	        il=jz+Nz*(jy+jx*Ny); image[jx][jy][jz].re=inp[il] ; 
                  } // for(jz=0...

   fftshift3(&image[0][0][0], N, 0);
   fftwnd_plan plan_forward = fftw3d_create_plan(Nx, Ny, Nz, FFTW_FORWARD, FFTW_ESTIMATE);
   fftwnd(plan_forward, 1, &image[0][0][0], 1, Nx*Ny*Nz, &fft_image[0][0][0], 1, Nx*Ny*Nz);
   fftwnd_destroy_plan(plan_forward);
   fftshift3(&fft_image[0][0][0], N, 0);
//    for(jx=0;jx<Nx;jx++)     for(jy=0;jy<Ny;jy++)   for(jz=0;jz<Nz;jz++) {
//	        fft_image[jx][jy][jz].re*=fft_koef;  fft_image[jx][jy][jz].im*=fft_koef;
//                  } // for(jz=0...

    double *filt;   filt=(double*) malloc(ngrid*sizeof(double));
    double scal=WindowData->K1[WindowData->Kend-1];

    for(jx=0;jx<Nx;jx++)     for(jy=0;jy<Ny;jy++)   for(jz=0;jz<Nz;jz++) {
	        il=jz+Nz*(jy+jx*Ny); rr[il]=sqrt(((double)jx-Nx/2)*((double)jx-Nx/2)+((double)jy-Ny/2)*((double)jy-Ny/2)+((double)jz-Nz/2)*((double)jz-Nz/2))/scal ; 
                  } // for(jz=0...
   WindowData->meyer(rr, filt, ngrid,2);
   for(il=0; il<ngrid; il++)   { filt[il]=filt[il]*filt[il]; if(rr[il]<=1.0) filt[il]=1.0; }

// filtering
    for(jx=0;jx<Nx;jx++)     for(jy=0;jy<Ny;jy++)   for(jz=0;jz<Nz;jz++) {
	        il=jz+Nz*(jy+jx*Ny); fft_image[jx][jy][jz].re=fft_image[jx][jy][jz].re*filt[il]*fft_koef; fft_image[jx][jy][jz].im=fft_image[jx][jy][jz].im*filt[il]*fft_koef;
                  } // for(jz=0...

   fftshift3(&fft_image[0][0][0], N, 0);
   fftwnd_plan plan_inv = fftw3d_create_plan(Nx, Ny, Nz, FFTW_BACKWARD, FFTW_ESTIMATE);
   fftwnd(plan_inv, 1, &fft_image[0][0][0], 1, Nx*Ny*Nz, &image[0][0][0], 1, Nx*Ny*Nz);
   fftwnd_destroy_plan(plan_inv);
   fftshift3(&image[0][0][0], N, 0);

      for(jx=0;jx<Nx;jx++)     for(jy=0;jy<Ny;jy++)   for(jz=0;jz<Nz;jz++) {
	        il=jz+Nz*(jy+jx*Ny); inp[il]=(float)(image[jx][jy][jz].re); 
                  } // for(jz=0...

   char IFile[1024]; sprintf(IFile, "./%s_rec_p",input_file);
   fid = fopen(IFile,"wb"); fwrite(&inp[0], sizeof(float), Nx*Ny*Nz, fid);  fclose (fid); 

   DMath::del(fft_image);  DMath::del(image);
   free(filt); free(rr);  free(inp); 

 return 0;
}



int DCurvelet::TransformScaleQuadPar(vector<fftw_complex> *vectv, vector<int> *vect1, int *cc_angles, fftw_complex ***fft_image, float **WindFuncsAll, int *Pbeg, int *Pend, int k, int ang1, int dang1, float penalty)
{  //      
 vector<int>::iterator it;

   int mm = US_OverSample;
   int N[3]; N[0]=Nk[0][k]; N[1]=Nk[1][k]; N[2]=Nk[2][k];
   int nboxpoints=N[0]*N[1]*N[2]; 
   double k_norm_ifft=1.0/sqrt((double)nboxpoints);

   fftwnd_plan  plan_inv_window = fftw3d_create_plan(N[0], N[1], N[2], FFTW_BACKWARD, FFTW_ESTIMATE);
   FILE *fid;
   int ii, ll, ix_angle, Ang_sym;

   fftw_complex *fft_box = DMath::newC(nboxpoints);
              memset(&fft_box[0], '\0', sizeof(fftw_complex)*nboxpoints);
   fftw_complex *ccoef_box = DMath::newC(nboxpoints);

 //  ----------  read block of data (quadrant) ----------------

            // loop over angles ! whole quadrant
  int loccount=0;
//   float penalty=INTERNAL_PENALTY;  

 for(ix_angle=ang1; ix_angle< (ang1+dang1); ix_angle++)  {
                   //  ----------  Smear out () ----------------

   E2UBox(fft_box, fft_image, Pbeg, Pend, k, ix_angle);


              // choosing proper window
     if(k==0)   {Ang_sym=0; } // cout << "Can not use function 'TransformScaleQuadPar' for k=0\n"; }  
     else  Ang_sym=ix_angle%(WindowData->N_nu_sym[k]);

   for(ii=0;ii<nboxpoints;ii++) {
        fft_box[ii].re = fft_box[ii].re*(WindFuncsAll[Ang_sym][ii])*k_norm_ifft;
        fft_box[ii].im = fft_box[ii].im*(WindFuncsAll[Ang_sym][ii])*k_norm_ifft;  
    } 
               //  ----------  IFFT () ----------------
    fftshift3(fft_box, N, 0);
    fftwnd(plan_inv_window, 1,  &fft_box[0], 1, 0,   &ccoef_box[0], 1, 0); // now fft_box contains output = curv. coefficients
    fftshift3(ccoef_box, N, 0);

      loccount=0;
      for(ll=0; ll<nboxpoints; ll++) {
            if(sqrt(ccoef_box[ll].re*ccoef_box[ll].re+ccoef_box[ll].im*ccoef_box[ll].im) < penalty) ; else {
                  loccount++;
                  vect1->push_back(ll); vectv->push_back(ccoef_box[ll]);
            }    // if(sqrt(ccoef...         
      }  // for(ll=0;...

     cc_angles[ix_angle-ang1]=loccount; 

   }  // for(ix_angle=0...

  fftwnd_destroy_plan(plan_inv_window);
   DMath::del(fft_box);  DMath::del(ccoef_box);

   return 0; 
}


int DCurvelet::InvTransformScaleQuadPar(vector<fftw_complex> *vectv, vector<int> *vect1, int *cc_angles, fftw_complex ***fft_image, float **WindFuncsAll, int *Pbeg, int *Pend, int k, int ang1, int dang1)
{
   int mm = US_OverSample;
   int N[3]; N[0]=Nk[0][k]; N[1]=Nk[1][k]; N[2]=Nk[2][k];
   int nboxpoints=N[0]*N[1]*N[2]; 
   double vvv, vvv1, k_norm_ifft=1.0/sqrt((double)nboxpoints);

     int dNx=Pend[0]-Pbeg[0], dNy=Pend[1]-Pbeg[1], dNz=Pend[2]-Pbeg[2];  

   fftwnd_plan  plan_window= fftw3d_create_plan(N[0], N[1], N[2], FFTW_FORWARD, FFTW_ESTIMATE);
   FILE *fid;
   int ii, ll, ix_angle, Ang_sym;

  fftw_complex *fft_box = DMath::newC(nboxpoints);
  fftw_complex *ccoef_box = DMath::newC(nboxpoints);

                     // prepare buffers for thresholing
  int glccount=0, loccount=0, bufmem= nboxpoints;
  int *buf_ind; 
  fftw_complex *buf_val;  


      // loop over angles !
 for(ix_angle=ang1; ix_angle< (ang1+dang1); ix_angle++)  {
      memset(&ccoef_box[0], '\0', sizeof(fftw_complex)*nboxpoints);
      for(ll=0; ll< cc_angles[ix_angle]; ll++) {
            ccoef_box[vect1->at(glccount+ll)].re=vectv->at(glccount+ll).re;  ccoef_box[vect1->at(glccount+ll)].im=vectv->at(glccount+ll).im;  }  
      glccount+=cc_angles[ix_angle];


     fftshift3(ccoef_box, N, 0);
     fftwnd(plan_window, 1, &ccoef_box[0], 1, 0, &fft_box[0], 1, 0);
     fftshift3(fft_box, N, 0);
 
      if(k==0)   Ang_sym=0;    else  Ang_sym=ix_angle%(WindowData->N_nu_sym[k]);
      for(ll=0;ll< nboxpoints; ll++) {
              fft_box[ll].re = fft_box[ll].re*(double)(WindFuncsAll[Ang_sym][ll]*k_norm_ifft);
              fft_box[ll].im = fft_box[ll].im*(double)(WindFuncsAll[Ang_sym][ll]*k_norm_ifft);
        } // for(ll=0 ...

        U2EBox(fft_image, fft_box, Pbeg, Pend, k, ix_angle, 1);
 } // for(ix_angle=0...

   fftwnd_destroy_plan(plan_window);
   DMath::del(fft_box);
   DMath::del(ccoef_box);

   return 0; 
}


